<?php
// $Id: pg_account.admin.inc,v 1.5 2009/11/24 22:06:35 gor Exp $
/********************************************************************
 * Functions callback
 ********************************************************************/
 
function pg_account_moneyout_history(){
  $filters = pg_account_build_filter_query('history_filter');
  $output = drupal_get_form('pg_account_filter_form','history_filter');
  $header = array(
    array('data' => t('ID'), 'field' => 't.txnid', 'sort' => 'desc'),
    array('data' => t('User'), 'field' => 'u.name'),
    array('data' => t('amount'), 'field' => 't.amount'),
    array('data' => t('Method'), 'field' => 't.method'),
    array('data' => t('payment status'), 'field' => 't.status'),
    array('data' => t('created'), 'field' => 't.created'),
    array('data' => t('changed'), 'field' => 't.changed'),
    t('Operations')
  );

  $sql='SELECT t.*,u.name FROM {pg_account_out_queue} t LEFT JOIN {users} u ON u.uid=t.uid '.$filters['join'].' '.$filters['where'].tablesort_sql($header);

  $result = pager_query($sql, variable_get('pg_showtransactions_default_num',10), 0, NULL, $filters['args']);

  while ($txn = db_fetch_object($result)) {
    $action=l(t('Edit'),'pgaccount_moneyout/edit/'.$txn->txnid);
    if($txn->status == PGACCOUNT_PENDING){
      $action .='<br>'. l(t('Send money'),'admin/content/pgaccount_moneyout/sendmoney/'.$txn->txnid);
    }
    $rows[] = array(
      $txn->txnid,
      l($txn->name, "user/".$txn->uid),
      $txn->amount,
      pg_account_get_method_name($txn->method),
      pg_account_get_status($txn->status),
      format_date($txn->created,'small'),
      format_date($txn->changed,'small'),
      $action
    );
  }//while
  if(empty($rows)){
    $rows[] = array(array('data' => t('No data available.'), 'colspan' => '7'));
  }
  $output.='<div width=99% style="overflow-x: auto; ">';
  $pager = theme('pager', NULL, variable_get('pg_showtransactions_default_num',10), 0);
  if (!empty($pager)) {
    $rows[] = array(array('data' => $pager, 'colspan' => 7));
  }
  $output .=  theme("table", $header, $rows);
  $output.="</div>";
  drupal_set_title($title);
  return $output;

}

function pg_account_moneyout_personal_history(){
  global $user;
  $filters = pg_account_build_filter_query('personal_history_filter');
  $output = drupal_get_form('pg_account_filter_form','personal_history_filter');
  $header = array(
    array('data' => t('ID'), 'field' => 't.txnid', 'sort' => 'desc'),
    array('data' => t('amount'), 'field' => 't.amount'),
    array('data' => t('Method'), 'field' => 't.method'),
    array('data' => t('payment status'), 'field' => 't.status'),
    array('data' => t('created'), 'field' => 't.created'),
    array('data' => t('changed'), 'field' => 't.changed'),
  );
  if(empty($filters['where'])){
    $filters['where'] = "WHERE t.uid='".$user->uid."'";
  } else {
    $filters['where'] .= " AND t.uid='".$user->uid."'";
  }
  $sql='SELECT t.* FROM {pg_account_out_queue} t '.$filters['join'].' '.$filters['where'].tablesort_sql($header);

  $result = pager_query($sql, variable_get('pg_showtransactions_default_num',10), 0, NULL, $filters['args']);

  while ($txn = db_fetch_object($result)) {
    $rows[] = array(
      $txn->txnid,
      $txn->amount,
      pg_account_get_method_name($txn->method),
      pg_account_get_status($txn->status),
      format_date($txn->created,'small'),
      format_date($txn->changed,'small'),
    );
  }//while
  if(empty($rows)){
    $rows[] = array(array('data' => t('No data available.'), 'colspan' => '6'));
  }
  $output.='<div width=99% style="overflow-x: auto; ">';
  $pager = theme('pager', NULL, variable_get('pg_showtransactions_default_num',10), 0);
  if (!empty($pager)) {
    $rows[] = array(array('data' => $pager, 'colspan' => 6));
  }

  $output .=  theme("table", $header, $rows);
  $output.="</div>";
  drupal_set_title($title);
  return $output;

}


function pg_account_fail ($t){
  global $user;
  if($user->uid!=1 && $user->uid != $t->uid){
    drupal_access_denied();
  }

  return theme('pg_account_fail',$t);
}


function pg_account_complete ($t){
  global $user;
  if($user->uid != 1 and $user->uid != $t->uid){
   drupal_access_denied();
  }
  
  return theme('pg_account_complete',$t);
}

function pg_account_payform($form_state,$t) {
  global $user;
  if($user->uid!=1 && $user->uid != $t->uid){
    drupal_access_denied();
  }
  $balance=pg_account_balance_load($user->uid);
  if($balance->balance < $t->amount * variable_get('pg_pgaccount_rate','1.00')){
    drupal_set_message(t('Please, fill up you account'),'error');
    return '';
  }
  $form['txnid'] = array(
    '#type' => 'value',
    '#value' => $t->txnid,
  );

  $form['title'] = array(
    '#type' => 'markup',
    '#value' => $t->title
  );

  $form['price'] = array(
    '#title' => t('Price'),
    '#type' => 'markup',
    '#value' => '<div>'.t('<b>Price:</b> %price %currency_symbol', array('%price'=> $t->amount , '%currency_symbol' => variable_get('pg_simplepay_symbol','$'))).'</div>'
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Place your order'),
  );
  return $form;
}

function pg_account_payform_submit($form, &$form_state){
  global $user;
  $txnid=$form_state['values']['txnid'];
  $t=pgapi_transaction_load($txnid);
  pg_account_balance_sub($user->uid,$t->amount);
  $t->status = pgapi_get_status_id('completed');
  pgapi_transaction_save($t);
  if($t->type == "pg_account")
    drupal_set_message(t('Your balance has been updated.'));
  $goto = pgapi_GetBackUrl($t);
  $form_state['redirect'] = $goto;
}

function pg_account_settings(){
  $form['pg_pgaccount_rate'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Rate to site currency'),
    '#default_value' => variable_get('pg_pgaccount_rate','1.00'),
    '#description'   => t("Please enter Account Balance rate according to site currency."),
  );
  $form['pg_pgaccount_symbol'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Symbol'),
    '#default_value' => variable_get('pg_pgaccount_symbol','$'),
    '#description'   => t("Please enter symbol of the Account Balance currency."),
  );

  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Update status of money out settings'),
  );

  return $form;
}


function pg_account_settings_validate($form, &$form_state) {
  if($form_state['values']['pg_pgaccount_rate']<=0){
    form_set_error('pg_pgaccount_rate', t('%rate must be more 0.', array('%rate' => $form_state['values']['pg_pgaccount_rate'])));
  }
}

function pg_account_settings_submit($form, &$form_state){

  if(isset($form_state['values']['pg_pgaccount_rate']))
    variable_set('pg_pgaccount_rate',$form_state['values']['pg_pgaccount_rate']);
  if(isset($form_state['values']['pg_pgaccount_symbol']))
    variable_set('pg_pgaccount_symbol',$form_state['values']['pg_pgaccount_symbol']);
}

function pg_account_edit_tmoney($form_state,$t){

  $form['txnid'] = array(
    '#type'        => 'value',
    '#value'       => $t->txnid,
  );

  $form['amount'] = array(
    '#type'        => 'textfield',
    '#title'       => t('Amount'),
    '#description' => t("Please enter amount to get from balance."),
    '#default_value' => $t->amount,
  );


  $options=array();
  foreach (module_implements('pgaccount_moneyout') as $module) {
    if ($module_name= module_invoke($module, 'pgaccount_moneyout','display name')) {
      $options[$module]=$module_name;
    }
  }
  $form['outby'] = array(
    '#title'       => t('Money out by'),
    '#type'        => 'select',
    '#options'     => $options,
    '#default_value' => $t->method,
    '#ahah' => array(
      'path'    => 'pgaccount/moneyout_js',
      'wrapper' => 'moneyout-wrapper-process',
      'method'  => 'replace',
      'effect'  => 'slide',
      'progress' => array('type' => 'div', 'wrapper' => 'moneyout-wrapper-process', 'div' => '<div style="display:block;">'.t('Please wait...').'</div>'),
     ),
  );
  $form['wrapper'] = array(
    '#prefix' => '<div id="moneyout-wrapper-process">',
    '#suffix' => '</div>',
  );
  $form['wrapper'] += pg_account_methodform($form_state,$t);

  $form['status'] = array(
    '#title'       => t('Status'),
    '#type'        => 'select',
    '#options'     => pg_account_build_status(),
    '#default_value' => $t->status,
  );

  $form['moneyout'] = array(
    '#type'  => 'submit',
    '#value' => t('Money out'),
  );

  return $form;
}
function pg_account_edit_tmoney_validate($form, &$form_state) {
  $txnid=$form_state['values']['txnid'];
  $t=pg_account_transaction_load($txnid);
  $status=$form_state['values']['status'];
  $amount=$form_state['values']['amount'];
  $balance=pg_account_balance_load($t->uid);
  if($amount > $balance->balance &&( $t->status != PGACCOUNT_COMPLETED && $status == PGACCOUNT_COMPLETED)) {
    form_set_error('amount', t('You cannot send %amount. Balance has only: %balance.', array('%balance' => $balance->balance, '%amount' => $amount)));
  }
}

function pg_account_edit_tmoney_submit($form, &$form_state){
  $txnid  = $form_state['values']['txnid'];
  $status = $form_state['values']['status'];
  $amount = $form_state['values']['amount'];
  $outby  = $form_state['values']['outby'];
  $t=pg_account_transaction_load($txnid);
  if($t->amount != $amount){
    $t->amount = $amount;
  }
  if($t->status != PGACCOUNT_COMPLETED && $status == PGACCOUNT_COMPLETED){
    $b=pg_account_balance_sub($t->uid,$t->amount);
    drupal_set_message(t('Balance has been changed'));
  }
  $name=pg_account_get_method_name($outby);
  if(!empty($name)) {
    $t->method=$outby;
  }
  $t->status=$status;
  $t->changed=time();
  drupal_write_record('pg_account_out_queue', $t,'txnid');
  $form_state['redirect'] = 'pgaccount_moneyout';
}

function pg_account_methodform($form_state,$t){

  $form['txnid'] = array(
    '#type'        => 'hidden',
    '#value'       => $t->txnid,
  );

  if($tfunction=module_invoke($t->method, 'pgaccount_moneyout','form function')){
    $form[$t->method] = array(
      '#type' => 'fieldset',
      '#title' => $tfunction['title'],
    );
    if($subfrm=$tfunction['func']($t)){
      $form[$t->method] += $subfrm;
    };
  }
  return $form;
}

function pg_account_moneyout_js(){
  $txnid=$_POST['txnid'];
  $outby=$_POST['outby'];
  $t=pg_account_transaction_load($txnid);
  $t->method=$outby;
  $form = pg_account_methodform($form_state,$t);
  $form = form_builder('pg_account_methodform', $form, $form_state);
  $output .= theme('status_messages') . drupal_render($form);
  print drupal_to_js(array('status' => TRUE, 'data' => $output));
  exit;
}

function pg_account_sendmoney($form_state,$t){
  $balance=pg_account_balance_load($t->uid);
  if($t->amount > $balance->balance) {
    drupal_set_message(t('You cannot send %amount. Balance has only: %balance.', array('%balance' => $balance->balance, '%amount' => $t->amount)),'error');
    $t->status=PGACCOUNT_FAILED;
    $t->changed=time();
    drupal_write_record('pg_account_out_queue', $t,'txnid');
    drupal_goto('pgaccount_moneyout');
  }else {
    $form['amount'] = array(
      '#type'        => 'markup',
      '#value'       => t('Amount').': '.$t->amount.'<br>',
    );
    $form['moneyout'] = pg_account_methodform($form_state,$t);
    $form['submit'] = array(
      '#type'  => 'submit',
      '#value' => t('Submit'),
    );
  }
  return $form;
}

function pg_account_sendmoney_submit($form, &$form_state){
  $txnid=$form_state['values']['txnid'];
  $t=pg_account_transaction_load($txnid);
  $amount=$t->amount;
  $b=pg_account_balance_sub($t->uid,$t->amount);
  drupal_set_message(t('Balance has been changed'));
  $t->status=PGACCOUNT_COMPLETED;
  $t->changed=time();
  drupal_write_record('pg_account_out_queue', $t,'txnid');
  $form_state['redirect'] = 'pgaccount_moneyout';
}

function pgaccount_common(){
  $form['#tree'] = TRUE;
  $pgaccount_moneyout=variable_get('pgaccount_moneyout',array());
  foreach (module_implements('pgaccount_moneyout') as $module) {
    if ($module_name= module_invoke($module, 'pgaccount_moneyout','display name')) {
      $form[$module]['modulename']=array ('#value' => $module_name);
      if($pgaccount_moneyout[$module]){
        $default='checked';
      }
      $form[$module]['checkbox']=array(
        '#type' => 'checkbox',
        '#default_value' => $default
      );
    }
  }


  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Update status of money out settings'),
  );

  return $form;
}


function pgaccount_common_submit($form, &$form_state){
  $pgapi_gw=array();
  foreach($form_state['values'] as $key => $val) {
    if($val['checkbox']==1){
      $pgaccount_moneyout[$key]=true;
    }
  }
  variable_set('pgaccount_moneyout',$pgaccount_moneyout);
  drupal_set_message(t('Status of money out has been updated.'));
}


function pg_account_moneyout_setting(){
  $res=array();
  foreach (module_implements('pgaccount_moneyout') as $module) {
    if ($datas= module_invoke($module, 'pgaccount_moneyout','data')) {
      foreach($datas as $key => $mdata){
        $res[$mdata['title']]=$mdata['values'];
      }//foreach
    }//if
  }//foreach
  return theme('pg_account_moneyout_setting',$res);
}


function pg_account_balance($form_state,$account=null){
  global $user;

  if($user->uid != 1 && $user->uid != $account->uid){
    drupal_access_denied();
  }
  $balance=pg_account_balance_load($account->uid);
  $form['balance'] = array(
   '#value' => t('Your current balance is: %currency %balance ',array('%balance' => $balance->balance ? $balance->balance : 0, '%currency' => variable_get('pg_pgaccount_symbol','$'))),
  );

  $form['uid'] = array (
      '#type'  => 'hidden',
      '#value' => $account->uid,
  );


  $form['fillup'] = array (
      '#type'  => 'fieldset',
      '#title' => t('Fill up')
  );
  
  $form['fillup']['fillup_amount'] = array(
    '#type'        => 'textfield',
    '#title'       => t('Fill up amount (!currency)',array('!currency'=>variable_get('pg_pgaccount_symbol','$'))),
    '#description' => t("Please enter amount to fill up balance."),
  );
  
  $form['fillup']['fillup'] = array(
    '#type'  => 'submit',
    '#value' => t('Filling up of balance'),
  );
  if(user_access('money out allowed')){  
    $form['moneyout'] = array (
      '#type'  => 'fieldset',
      '#title' => t('Money out')
    );
	  $form['moneyout']['moneyout_amount'] = array(
	    '#type'        => 'textfield',
	    '#title'       => t('Amount'),
	    '#description' => t("Please enter amount to get from balance."),
	  );
	  $options=array();
	  foreach (module_implements('pgaccount_moneyout') as $module) {
	    if ($module_name= module_invoke($module, 'pgaccount_moneyout','display name')) {
	      $options[$module]=$module_name;
	    }
	  }
	  $form['moneyout']['outby'] = array(
	    '#title'       => t('Money out by'),
	    '#type'        => 'select',
	    '#options'     => $options,
	  );
	
	  $form['moneyout']['moneyout'] = array(
	    '#type'  => 'submit',
	    '#value' => t('Money out'),
	  );
	  $form['moneyout']['history'] = array(
	    '#type'  => 'markup',
	    '#value' => '<div>'.l(t("Money out history."),'user/'.$account->uid.'/setting/history').'</div>',
	  );
  }
  return $form;
}

function pg_account_balance_validate($form, &$form_state){
  global $user;
  
  $op=$form_state['values']['op'];
  $moneyout=$form_state['values']['moneyout'];
  $balance=pg_account_balance_load($user->uid);
  $amount=$form_state['values']['moneyout_amount'];


  if($op==$moneyout && $amount > $balance->balance) {
    form_set_error('amount', t('You cannot out more than %balance.', array('%balance' => $balance->balance)));
  }
}


function pg_account_balance_submit($form, &$form_state){
  global $user;
  
  $account =user_load($form_state['values']['uid']);  
  $op=$form_state['values']['op'];
  $fillup=$form_state['values']['fillup'];
  $moneyout=$form_state['values']['moneyout'];


  if($op==$fillup){
    $t = (object)(NULL);
    $t->amount=$form_state['values']['fillup_amount'] / variable_get('pg_account_rate','1.00');
    $t->type='pg_account';
    $t->uid=$account->uid;
    $t->title=t('Filling up of balance');
    $t = pgapi_transaction_save($t);
    $form_state['redirect'] = 'payment/'. $t->txnid;
  }elseif ($op==$moneyout) {
    $t = (object)(NULL);
    $t->amount=$form_state['values']['moneyout_amount'];
    $t->method=$form_state['values']['outby'];
    $t->uid=$account->uid;
    $t->status=PGACCOUNT_PENDING;
    $t->created=time();
    $t->changed=time();
    drupal_write_record('pg_account_out_queue', $t);
    drupal_set_message(t('Your request has been added'));
    $form_state['redirect'] = 'user/'.$account->uid.'/setting/history';
  }
}

/********************************************************************
 * Other Functions
 ********************************************************************/
function pg_account_filter_form($form_state,$sess){
  $sess='pg_account_'.$sess;
  $session = &$_SESSION[$sess];
  $session = is_array($session) ? $session : array();
  $filtersfunction=$sess.'s';
  $filters = $filtersfunction();
  $options=array();
  
  $i = 0;
  $form['session_name']= array ('#type' => 'hidden', '#value' => $sess);
  $form['filters'] = array('#type' => 'fieldset',
                       '#title' => t('Show payment where'),
                       '#theme' => 'pg_showtransactions_filters',
                     );
  foreach ($session as $filter) {
    list($type, $value) = $filter;
    // Merge an array of arrays into one if necessary.
    if($filters[$type]['type']=='textfield'){
     $params = array('%property' => $filters[$type]['title'] , '%value' => $value);
    }else{
      $options = $type == 'permission' ? call_user_func_array('array_merge', $filters[$type]['options']) : $filters[$type]['options'];
      $params = array('%property' => $filters[$type]['title'] , '%value' => $options[$value]);
    }
    if ($i++ > 0) {
      $form['filters']['current'][] = array('#value' => t('<em>and</em> where <strong>%property</strong> is <strong>%value</strong>', $params));
    }
    else {
      $form['filters']['current'][] = array('#value' => t('<strong>%property</strong> is <strong>%value</strong>', $params));
    }
    unset($filters[$type]);
  }

  foreach ($filters as $key => $filter) {
    $names[$key] = $filter['title'];
    if($filter['type'] == "textfield"){
     $form['filters']['status'][$key] = array('#type' => 'textfield','#size' => 23);
    }else{
      if(empty($filter['options'])){
        $filter['options']=array();
      }
      $form['filters']['status'][$key] = array('#type' => 'select',
                                         '#options' => $filter['options'],
                                       );
    }
  }

  $form['filters']['filter'] = array('#type' => 'radios',
                                 '#options' => $names,
                               );
  $form['filters']['buttons']['submit'] = array('#type' => 'submit',
                                            '#value' => (count($session) ? t('Refine') : t('Filter'))
                                          );
  if (count($session)) {
    $form['filters']['buttons']['undo'] = array('#type' => 'submit',
                                            '#value' => t('Undo')
                                          );
    $form['filters']['buttons']['reset'] = array('#type' => 'submit',
                                             '#value' => t('Reset')
                                           );
  }

  return $form;
}


function pg_account_filter_form_submit($form, &$form_state) {
  $op = $form_state['values']['op'];
  $sess=$form_state['values']['session_name'];
  $filterfunction = $sess.'s';
  $filters = $filterfunction();
  $options=array();
  
  switch ($op) {
    case t('Filter'): case t('Refine'):
      if (isset($form_state['values']['filter'])) {
        $filter = $form_state['values']['filter'];
        // Merge an array of arrays into one if necessary.
        if($filters[$filter]['type'] == 'textfield'){
          $_SESSION[$sess][] = array($filter, $form_state['values'][$filter]);
        }else{
          $options = $filter == 'permission' ? call_user_func_array('array_merge', $filters[$filter]['options']) : $filters[$filter]['options'];
          if (isset($options[$form_state['values'][$filter]])) {
            $_SESSION[$sess][] = array($filter, $form_state['values'][$filter]);
          }
        }
      }
      break;
    case t('Undo'):
      array_pop($_SESSION[$sess]);
      break;
    case t('Reset'):
      $_SESSION[$sess] = array();
      break;
    case t('Update'):
      return;
  }
}


function pg_account_personal_history_filters(){
  $filters = array();
  $filters['ID']= array('type'  => 'textfield',
                          'title' => t('ID'),
                          'where' => "t.txnid='%s'",
                       );
  $filters['price']= array('type'  => 'textfield',
                          'title' => t('Amount'),
                          'where' => "t.amount='%f'",
                       );

  $filters['method']= array('title' => t('Method'),
                         'where' => "t.method = '%s'",
                         'options' => pg_account_build_method(),
                       );

  $filters['status'] = array('title' => t('money out status'),
                         'where' => 't.status = %d',
                         'options' => pg_account_build_status(),
                       );



  return $filters;
}


function pg_account_history_filters(){
  $filters = array();
  $filters['ID']= array('type'  => 'textfield',
                          'title' => t('ID'),
                          'where' => "t.txnid='%s'",
                       );
  $filters['name']= array('type'  => 'textfield',
                          'title' => t('User'),
                          'where' => "u.name='%s'",
                       );

  $filters['price']= array('type'  => 'textfield',
                          'title' => t('Amount'),
                          'where' => "t.amount='%f'",
                       );

  $filters['method']= array('title' => t('Method'),
                         'where' => "t.method = '%s'",
                         'options' => pg_account_build_method(),
                       );

  $filters['status'] = array('title' => t('money out status'),
                         'where' => 't.status = %d',
                         'options' => pg_account_build_status(),
                       );



  return $filters;
}


function pg_account_build_filter_query($sess) {
  $sess='pg_account_'.$sess;
  $filterfunction = $sess.'s';
  $filters = $filterfunction();

  // Build query
  $where = $args = $join = array();
  if(isset($_SESSION[$sess])){
    foreach ($_SESSION[$sess] as $filter) {
      list($key, $value) = $filter;
      $where[] = $filters[$key]['where'];
      $args[] = $value;
      $join[] = $filters[$key]['join'];
    }
  }
  $where = count($where) ? 'WHERE '. implode(' AND ', $where) : '';
  $join = count($join) ? ' '. implode(' ', array_unique($join)) : '';

  return array('where' => $where,
           'join' => $join,
           'args' => $args,
         );
}
