<?php
/********************************************************************
 * Functions callback
 ********************************************************************/
function pgapi_pgdata (){
  $item = menu_get_item('admin/pgdata');
  $content = system_admin_menu_block($item);
  $output = theme('admin_block_content', $content);
  return $output;
}


function pgapi_payment (&$form_state,$t){
  global $user;
  if(($user->uid != 1 && $user->uid != $t->uid) OR ($t->status != PG_PENDING) OR ($t->workflow != PG_WORKFLOW_RECEIVED)){
    drupal_access_denied();
  }
  $pgapi_gw=pgapi_getActivePG();
  $default='';
  if(!empty($t->method)){
    $default=$t->method;
  }
  foreach ($pgapi_gw as $module => $checked) {
      if($checked){
        if ($module_data= module_invoke($module, 'pgapi_gw','payment gateway info',$t->amount,$t)) {

          $form[$module]['modulename']=array (
            '#value' => $module_data['name'],
          );
          $options[$module]='';
          if(empty($default))
             $default=$module;
          $form[$module]['price']=array (
          '#value' => theme('pgapi_gateway_price',$module_data['price'],$t->type),
          );
        }
      }
      $form['method']=array(
        '#type'    => 'radios',
        '#options' => $options,
        '#default_value' => $t->method ? $t->method : $default,
        '#ahah'   => array(
           'path'    => 'payment/form_load_js/'.$t->txnid,
           'wrapper' => 'pgapi-wrapper-form',
           'method'  => 'replace',
           'effect'  => 'slide',
           'progress' => array('type' => 'throbber', 'message' => t('Please wait...')),
        ),
      );
  }
  
  $form['pgapi_wrapper'] = array(
    '#prefix' => '<div id="pgapi-wrapper-form">',
    '#suffix' => '</div>'
  );
  
  if(!empty($default)){
    $extra_form=module_invoke($default, 'pgapi_gw','get form', $t,$form_state);
    if(is_array($extra_form)){
      $form['pgapi_wrapper'] += $extra_form;
    }
  }  
  $form['#tree']=TRUE;

  $form['txnid']=array(
    '#type'  => 'value',
    '#value' => $t->txnid,
  );
  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Process purchase'),
  );
  $form['cancel'] = array(
    '#type'  => 'submit',
    '#value' => t('Cancel purchase'),
  );
  return $form;
}


function pgapi_payment_submit($form, &$form_state) {
  $t=pgapi_transaction_load($form_state['values']['txnid']);
  $t = module_invoke($form_state['values']['method'], 'pgapi_gw','process form',$t ,$form_state['values']['pgapi_wrapper']);
  $form_state['redirect'] =  pgapi_GetBackUrl($t);
 
}


function pgapi_common() {
  $form['#tree'] = TRUE;
  $pgapi_gw=variable_get('pgapi_gw',array());
  foreach (module_implements('pgapi_gw') as $module) {
    if ($module_name= module_invoke($module, 'pgapi_gw','display name')) {
      $form[$module]['modulename']=array ('#value' => $module_name);
      $default='';
      if($pgapi_gw[$module]){
        $default='checked';
      }
      $form[$module]['checkbox']=array(
        '#type' => 'checkbox',
        '#default_value' => $default
      );
    }
  }

  $form['submit'] = array(
    '#type'  => 'submit',
    '#value' => t('Update status of payment gateways'),
  );

  return $form;
}

function pgapi_common_submit($form, &$form_state){
  $pgapi_gw=array();
  foreach($form_state['values'] as $key => $val) {
    if($val['checkbox']==1){
      $pgapi_gw[$key]=true;
    }
  }
  variable_set('pgapi_gw',$pgapi_gw);
  drupal_set_message(t('Status of payment gateway has been updated.'));
}



/********************************************************************
 * Other Functions
 ********************************************************************/
